#define MKSTR(s) #s

#define TABSIZE_L2 8
#define TABSIZE    (1<<TABSIZE_L2)
#define TABMASK    (TABSIZE-1)

        .section .rodata.btab.name, "aS", %progbits
        .section .rodata.btab.nptr, "a",  %progbits
        .section .rodata.bfun.name, "aS", %progbits
        .section .rodata.bfun.tab,  "a",  %progbits

        .macro bfun name
        .pushsection .rodata.bfun.name
        .set bfname, .
        .asciz MKSTR(\name)
        .section .rodata.bfun.tab
        .word bfname
        .word \name
        .set bftab, .
        .popsection
        function \name, export=1
        ldr             r2,  =branch_tab
        add             r1,  r2,  r1,  lsl #TABSIZE_L2
        mov             r2,  #0
        .endm

        .macro btab name
        .pushsection .rodata.btab.name
        .set btname, .
        .asciz MKSTR(\name)
        .section .rodata.btab.nptr
        .word btname
        .set btnptr, .
        .popsection
        .endm

        .macro  function name, export=0
.if \export
        .global \name
.endif
        .type   \name, %function
        .func   \name
\name:
        .endm

        .macro  xmov r, cond
.if \cond
        mov             \r,  \r
.endif
        .endm

        .macro  ccnt_init
        mov             ip,  #15
        mcr             p15, 0,   ip,  c9,  c12, 2
        mov             ip,  #1<<31
        mcr             p15, 0,   ip,  c9,  c12, 1
        mov             ip,  #5
        mcr             p15, 0,   ip,  c9,  c12, 0
        .endm

        .macro  ccnt_read rd
        mrc             p15, 0,   \rd, c9,  c13, 0
        .endm

        .text

        .macro  brdelay d
        .align 6
bfun delay\d
        ccnt_init
1:      ldrb            r3,  [r1, r2]
        add             r2,  r2,  #1
        mov             r0,  r0
        xmov            r4,  \d < 1
        xmov            r5,  \d < 2
        xmov            r6,  \d < 3
        xmov            r7,  \d < 4
        tst             r3,  #1
        xmov            r8,  \d > 0
        xmov            r9,  \d > 1
        xmov            r10, \d > 2
        xmov            r11, \d > 3
        beq             2f
        subs            r0,  r0,  #1
        and             r2,  r2,  #TABMASK
        bne             1b
        ccnt_read       r0
        bx              lr
2:      subs            r0,  r0,  #1
        and             r2,  r2,  #TABMASK
        bne             1b
        ccnt_read       r0
        bx              lr
        .endfunc
        .endm

        brdelay 0
        brdelay 1
        brdelay 2
        brdelay 3
        brdelay 4

        .macro  looptail
        subs            r0,  r0,  #1
        and             r2,  r2,  #TABMASK
        bne             1b
        ccnt_read       r0
        bx              lr
        .endm

bfun jmptab
        ccnt_init
1:      ldrb            r3,  [r1, r2]
        adr             ip,  50f
        ands            r3,  r3,  #3
        add             r2,  r2,  #1
        beq             10f
        ldr             pc,  [ip, r3, lsl #2]
10:     looptail
20:     looptail
30:     looptail
40:     looptail
50:     .word           10b
        .word           20b
        .word           30b
        .word           40b
        .endfunc

bfun cbranch
        ccnt_init
1:      ldrb            r3,  [r1, r2]
        add             r2,  r2,  #1
        ands            r3,  r3,  #3
        beq             20f
        subs            r3,  r3,  #1
        beq             30f
        subs            r3,  r3,  #1
        beq             40f
10:     looptail
20:     looptail
30:     looptail
40:     looptail
        .endfunc

        .align 6
function func0
        bx              lr
        .endfunc

        .align 4
function func1
        bx              lr
        .endfunc

        .align 6
bfun ccall1
        push            {lr}
        ccnt_init
1:      ldrb            r3,  [r1, r2]
        add             r2,  r2,  #1
        tst             r3,  #1
        bleq            func0
        blne            func1
        subs            r0,  r0,  #1
        and             r2,  r2,  #TABMASK
        bne             1b
        ccnt_read       r0
        pop             {pc}
        .endfunc

        .align 6
bfun ccall2
        push            {lr}
        ccnt_init
1:      ldrb            r3,  [r1, r2]
        add             r2,  r2,  #1
        tst             r3,  #1
        adreq           ip,  func0
        adrne           ip,  func1
        blx             ip
        subs            r0,  r0,  #1
        and             r2,  r2,  #TABMASK
        bne             1b
        ccnt_read       r0
        pop             {pc}
        .endfunc

        .align 4
function func2
        mov             r0,  r0
        mov             r1,  r1
        mov             r2,  r2
        mov             r3,  r3
        mov             r4,  r4
        mov             r5,  r5
        mov             r6,  r6
        mov             r7,  r7
        bx              lr
        .endfunc

        .align 6
bfun funcall
        push            {lr}
        ccnt_init
1:      ldrb            r3,  [r1, r2]
        add             r2,  r2,  #1
        bl              func2
        subs            r0,  r0,  #1
        and             r2,  r2,  #TABMASK
        bne             1b
        ccnt_read       r0
        pop             {pc}
        .endfunc

        .align 4
function func3
        mov             r0,  r0
        mov             r1,  r1
        mov             r2,  r2
        mov             r3,  r3
        mov             r4,  r4
        mov             r5,  r5
        mov             r6,  r6
        mov             r7,  r7
        mov             pc,  lr
        .endfunc

        .align 6
bfun funcall2
        push            {lr}
        ccnt_init
1:      ldrb            r3,  [r1, r2]
        add             r2,  r2,  #1
        bl              func2
        subs            r0,  r0,  #1
        and             r2,  r2,  #TABMASK
        bne             1b
        ccnt_read       r0
        pop             {pc}
        .endfunc

        .align 6
bfun inline
        push            {lr}
        ccnt_init
1:      ldrb            r3,  [r1, r2]
        add             r2,  r2,  #1
        mov             r0,  r0
        mov             r1,  r1
        mov             r2,  r2
        mov             r3,  r3
        mov             r4,  r4
        mov             r5,  r5
        mov             r6,  r6
        mov             r7,  r7
        subs            r0,  r0,  #1
        and             r2,  r2,  #TABMASK
        bne             1b
        ccnt_read       r0
        pop             {pc}
        .endfunc

        .section .rodata

        .macro alt n
        btab alt\n
        .rept (TABSIZE/2)/\n
        .rept \n
        .byte 0
        .endr
        .rept \n
        .byte 1
        .endr
        .endr
        .endm

        .macro rand n
        btab rand\n
        .rept TABSIZE/\n
        .incbin "random.bin", 0, \n
        .endr
        .endm

        .align TABSIZE_L2
branch_tab:
        rand 256
        rand 128
        rand 64
        rand 32
        rand 16
        rand 8

        alt 1
        alt 2
        alt 4
        alt 8
        alt 16
        alt 32

        btab zero
        .rept TABSIZE
        .byte 0
        .endr

        btab one
        .rept TABSIZE
        .byte 1
        .endr

        .size branch_tab, . - branch_tab

        .global btab_names
        .set    btab_names, .rodata.btab.nptr

        .global btab_count
btab_count:
        .word (btnptr - .rodata.btab.nptr) / 4

        .global bfun_tab
        .set    bfun_tab, .rodata.bfun.tab

        .global bfun_count
bfun_count:
        .word (bftab - .rodata.bfun.tab) / 8
